/* SFX Pan */

OPTIONS RESULTS
ADDRESS REXX_SFX

GetActiveBuffer
buf1=RESULT
IF buf1>-1 THEN DO
	GetChannels buf1
	cha=RESULT
	IF cha=1 THEN DO
		SelOperator 'ConvertChannels'					/* make Stereo */
		SetOperatorParam 'ConvertChannels' 'Dest' '1'
		ProcessSample buf1
		IF RC=0 THEN buf1=RESULT
		ELSE buf1=-2
		buf2=-1
		IF buf1>-1 THEN DO							/* RampUp first channel */
			SelOperator 'Amplify'
			SetOperatorParam 'Amplify' 'Wrap' '0'
			SetOperatorParam 'Amplify' 'P1ModShape' 'Linear'
			DisableChannel buf1 1
			SetOperatorParam 'Amplify' 'AmpfS' '0.0'
			SetOperatorParam 'Amplify' 'AmpfE' '1.0'
			ProcessSample buf1
			IF RC=0 THEN buf2=RESULT
			ELSE buf2=-2
			RemoveBuffer buf1
		END
		ELSE Message '"Operator ConvertChannels failed !"'
		buf1=-1
		IF buf2>-1 THEN DO							/* RampDown second channel */
			EnableChannel buf2 1
			DisableChannel buf2 0
			SetOperatorParam 'Amplify' 'AmpfS' '1.0'
			SetOperatorParam 'Amplify' 'AmpfE' '0.0'
			ProcessSample buf2
			IF RC=0 THEN buf1=RESULT
			ELSE buf1=-2
			RemoveBuffer buf2
		END
		ELSE Message '"Operator Amplify failed !"'
		IF buf1>-1 THEN DO
			EnableChannel buf1 0
			RedrawBuffer buf1
			SetActiveBuffer buf1
			CleanUp 0
		END
		ELSE Message '"Operator Amplify failed !"'
	END
	ELSE Message '"Mono source required !"'
END
ELSE Message '"No sample to operate on !"'
ActivateSFX
EXIT
